首页 > 代码库 > hdu 2602 Bone Collector
hdu 2602 Bone Collector
简单的01背包,题意很清晰啊。
对于背包问题我有一个建议就是都做题。
Bone Collector
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 27979 Accepted Submission(s): 11404
Problem Description
Many years ago , in Teddy’s hometown there was a man who was called “Bone Collector”. This man like to collect varies of bones , such as dog’s , cow’s , also he went to the grave …
The bone collector had a big bag with a volume of V ,and along his trip of collecting there are a lot of bones , obviously , different bone has different value and different volume, now given the each bone’s value along his trip , can you calculate out the maximum of the total value the bone collector can get ?
The bone collector had a big bag with a volume of V ,and along his trip of collecting there are a lot of bones , obviously , different bone has different value and different volume, now given the each bone’s value along his trip , can you calculate out the maximum of the total value the bone collector can get ?
Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, (N <= 1000 , V <= 1000 )representing the number of bones and the volume of his bag. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Followed by T cases , each case three lines , the first line contain two integer N , V, (N <= 1000 , V <= 1000 )representing the number of bones and the volume of his bag. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Output
One integer per line representing the maximum of the total value (this number will be less than 231).
Sample Input
1 5 10 1 2 3 4 5 5 4 3 2 1
Sample Output
14
Author
Teddy
Source
HDU 1st “Vegetable-Birds Cup” Programming Open Contest
/* 问题分析:第二行输入骨头的value[1001],第二行输入骨头的volume[1001] 我们要得到状态方程dp[i][j]=max(dp[i-1][j],dp[i-1][j-volume[i]]+value[i]) 方程解释:当装入第i个骨头时我们应该考虑到装入第i-1个骨头的价值dp[i][j], 我们要比较装入第i与没有装第i个的价值的比较。没有装入第i个就是将第i-1个装入体积为j的包中 当装入第i个时就是把第i-1个装入体积为j-volume[i]的包裹中,但是由于装入了第i个所以它的的价值增加了value[i]; */ #include<iostream> #include<cstring> using namespace std; int max(int a,int b) { if(a>b) return a; else return b; } int main(int i,int j) { int t;//测试样例 int n;//总骨头数目 int v;//总的包的体积 int static dp[1001][1001];//最后的最大价值 int value[1001];//单个骨头的价值 int volume[1001];//单个骨头的体积 cin>>t; while(t--) { cin>>n>>v; for(i=1;i<=n;i++) cin>>value[i]; for(i=1;i<=n;i++) cin>>volume[i]; memset(dp,0,sizeof(dp)); for(i=1;i<=n;i++) { for(j=0;j<=v;j++) { if(j>=volume[i]) dp[i][j]=max(dp[i-1][j],dp[i-1][j-volume[i]]+value[i]); else dp[i][j]=dp[i-1][j]; } } cout<<dp[n][v]<<endl; } return 0; }
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。